//------------------------------------------------------------------------------
// shape_Constr.cpp -     
//     
//------------------------------------------------------------------------------

#include <iostream>
#include "shape_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .
  void Init(rectangle &r, int x, int y);
  void Init(triangle &t, int a, int b, int c);
  void Init(circle &c, int r);    //  

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_rectangle(int x, int y)
  {
    shape *s = new shape;
    s->k = shape::key::RECTANGLE;
    Init(s->r, x, y);
    return s;
  }

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_triangle(int a, int b, int c)
  {
    shape *s = new shape;
    s->k = shape::key::TRIANGLE;
    Init(s->t, a, b, c);
    return s;
  }

//------------------------------------------------------------------------------

  //     
  shape *Create_shape_circle(int r)
  {
    shape *s = new shape;
    s->k = shape::key::CIRCLE;
    Init(s->c, r);
    return s;
  }

//------------------------------------------------------------------------------

  //   
  void Init_rectangle(shape &s, int x, int y)
  {
    s.k = shape::key::RECTANGLE;
    Init(s.r, x, y);
  }

//------------------------------------------------------------------------------

  //   
  void Init_triangle(shape &s, int a, int b, int c)
  {
    s.k = shape::key::TRIANGLE;
    Init(s.t, a, b, c);
  }

//------------------------------------------------------------------------------

  //    
  void Init_circle(shape &s, int r)
  {
    s.k = shape::key::CIRCLE;
    Init(s.c, r);
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
